import greenfoot.World;
import greenfoot.GreenfootImage;
import greenfoot.Greenfoot;
import java.awt.Color;
import java.awt.Point;

/**
 * Screen
 * 
 * @author Taylor Born
 * @version September 2013
 */
public class Screen extends World
{
    static final int S = 7;

    public Screen()
    {
        super((int)Math.pow(2, S) * 3 + 200, (int)Math.pow(2, S) * 3, 1);
        
//         int t = 
//         
//         // Find a square (with even side length) that fits all the characters of t
//         int n;
//         for (n = 2; n * n < t.length(); n += 2)
//         {}
//         
//         // Add enough ',' to fill square
//         for (int i = 0; t.length() < n * n; t += ",")
//         {}
        
        // Square with even side length
        int n = (int)Math.pow(2, S);
        
        // Add chars in square by algorithm
        // Example: (4x4 square)
        //
        // 1 13  3  5
        // 6 10 14 12
        // 9 15 11  7
        // 8  2 16  4
        //
        // 1-4   is added when i=0 (i%2=0)
        // 5-8   is added when i=1 (i%2=1)
        // 9-12  is added when i=2 (i%2=0)
        // 13-16 is added when i=3 (i%2=1)
        //
        int[][] b = new int[n][n];
        for (int i = 0; i < n; i++)
            if (i % 2 == 0)
            {
                for (int k = 0; k < n; k++)
                    if (k % 2 == 0)
                        b[i][k] = i * n + k + 1;
                    else
                        b[(n - 1) - i][k] = i * n + k + 1;
            }
            else
                for (int k = 0; k < n; k++)
                    if (k % 2 == 0)
                        b[k][(n - 1) - (i - 1)] = i * n + k + 1;
                    else
                        b[k][i - 1] = i * n + k + 1;
        GreenfootImage pic = new GreenfootImage(getWidth(), getHeight());
        pic.setColor(Color.WHITE);
        pic.fill();
        pic.setColor(Color.BLACK);
        pic.drawLine(n * 3, 0, n * 3, getHeight());

        for (int r = 0; r < n; r++)
            for (int c = 0; c < n; c++)
                if (PrimeUtil.isPrime(b[r][c]))
                    pic.fillRect(c * 3, r * 3, 3, 3);
        
//         int ds = 6 * 3;
//         pic.setColor(Color.GREEN);
//         for (int r = 0; r < getHeight() - ds; r++)
//             for (int c = 0; c < getWidth() - ds; c++)
//                 if (!pic.getColorAt(c, r).equals(Color.BLACK))
//                 {
//                     boolean found = false;
//                     outer: for (int rr = r; rr - r < ds; rr++)
// //                         if (rr >= getHeight() - ds)
// //                         {
// //                             found = true;
// //                             break outer;
// //                         }
// //                         else
//                             for (int cc = c; cc - c < ds; cc++)
//                                 if (pic.getColorAt(cc, rr).equals(Color.BLACK))//cc >= getWidth() - ds || 
//                                 {
//                                     found = true;
//                                     break outer;
//                                 }
//                     if (!found)
//                         pic.fillRect(c, r, ds, ds);
//                 }
        
        setBackground(pic);
        
        Container c = new Container(new Point(1, 4), 30);
        Container isC = new Container(new Point(1, 2), 4);
        isC.addComponent(isPrimeInput);
        isC.addComponent(isPrimeBtn);
        c.addComponent(isC);
        Container nthC = new Container(new Point(1, 2), 4);
        nthC.addComponent(nthPrimeInput);
        nthC.addComponent(nthPrimeBtn);
        c.addComponent(nthC);
        Container piC = new Container(new Point(1, 2), 4);
        piC.addComponent(piInput);
        piC.addComponent(piBtn);
        c.addComponent(piC);
        c.addComponent(printBtn);
        addObject(c, (int)Math.pow(2, S) * 3 + 200 / 2, getHeight() / 2);
        
        isPrimeInput.acceptOnly(TextBox.NUMBERS);
        nthPrimeInput.acceptOnly(TextBox.NUMBERS);
        piInput.acceptOnly(TextBox.NUMBERS + ".");
        
        isPrimeInput.setMessage("integer");
        nthPrimeInput.setMessage("n");
        piInput.setMessage("double");
        
        Window.setDefaultColorScheme(new Color(255, 255, 200), Color.BLACK);
        
        Greenfoot.start();
    }
    
    private TextBox isPrimeInput = new TextBox(new Point(120, 18), "");
    private TextBox nthPrimeInput = new TextBox(new Point(120, 18), "");
    private TextBox piInput = new TextBox(new Point(120, 18), "");
    private Button isPrimeBtn = new Button("Is prime?", new Point(120, 18));
    private Button nthPrimeBtn = new Button("Get nth prime", new Point(120, 18));
    private Button piBtn = new Button("Calculate pi", new Point(120, 18));
    
    private Button printBtn = new Button("Print", new Point(120, 18));
    
    public void act()
    {
        if (isPrimeBtn.wasClicked())
        {
            try
            {
                int num = Integer.parseInt(isPrimeInput.getText());
                (new MessageWindow(num + " is " + (PrimeUtil.isPrime(num) ? "" : "not ") + "prime.")).toggleShow();
            }
            catch (Exception e)
            {
                (new MessageWindow("Invalid input")).toggleShow();
            }
        }
        if (nthPrimeBtn.wasClicked())
        {
            try
            {
                int num = Integer.parseInt(nthPrimeInput.getText());
                (new MessageWindow("The " + num + " prime is " + PrimeUtil.getPrime(num) + ".")).toggleShow();
            }
            catch (Exception e)
            {
                (new MessageWindow("Invalid input")).toggleShow();
            }
        }
        if (piBtn.wasClicked())
        {
            try
            {
                double num = Double.parseDouble(piInput.getText());
                (new MessageWindow("pi(" + num + ") = " + PrimeUtil.pi(num))).toggleShow();
            }
            catch (Exception e)
            {
                (new MessageWindow("Invalid input")).toggleShow();
            }
        }
        if (printBtn.wasClicked())
            PrimeUtil.printPrimes();
    }
}